#include <TFile.h>
#include <TTree.h>
#include <TObject.h>

#include "Hit.h"
#include "Track.h"
#include "Event.h"

int main() {

  TFile tfile("test.root", "RECREATE");
  TTree ttree("test", "test TTree");
  Event event;
  ttree.Branch("test_branch", "Event", &event);

  {
    Track * track1 = event.AddTrack();
    Hit * hit1 = event.AddHit();
    hit1->parent_track = track1;
    track1->hits.Add((TObject *) hit1);

    Track * track2 = event.AddTrack();
    Hit * hit2 = event.AddHit();
    hit2->parent_track = track2;
    track2->hits.Add((TObject *) hit2);
    track2->parent_track = track1;

    event.RemoveTrack(track1);

    ttree.Fill();
  }
  {
    Track * track1 = event.AddTrack();
    Hit * hit1 = event.AddHit();
    hit1->parent_track = track1;
    track1->hits.Add((TObject *) hit1);

    Track * track2 = event.AddTrack();
    Hit * hit2 = event.AddHit();
    hit2->parent_track = track2;
    track2->hits.Add((TObject *) hit2);
    track2->parent_track = track1;

    event.RemoveTrack(track1);
    event.RemoveTrack(track2);
  }

  ttree.Fill();
  
  tfile.Write();
  tfile.Close();

  
  std::exit(0);
}
